/* $Id: main.cpp 397 2010-04-17 16:03:52Z oh2gve $
 *
 * Copyright 2010, 2011 Tapio Aaltonen
 *
 *
 * This file is part of aprsg.
 *
 * aprsg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * aprsg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with aprsg.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * APRS is a registered trademark of APRS Software and Bob Bruninga, WB4APR.
*/

// Own stuff.
#include "controller.h"

// Std stuff.
#include <vector>
using std::vector;

// Wx stuff.
#include <wx/app.h>
#include <wx/frame.h>
#include <wx/log.h>
#include <wx/string.h>
#include <wx/event.h>


Controller::Controller(wxFrame* parent, Cfg::Configuration const& cfg,
                       Uplink* uplink, vector<Connection*>& cons,
                       Packetlog* packetlog):
wxThread(wxTHREAD_JOINABLE),
parent_(parent), configuration_(cfg), uplink_(uplink), connections_(cons),
packetlog_(packetlog)
{
}


Controller::~Controller()
{
}


void Controller::eventToMain(EventID id, wxString const& text)
{
	wxCommandEvent e (wxEVT_COMMAND_TEXT_UPDATED, id);
	e.SetString(text);
	parent_->GetEventHandler()->AddPendingEvent(e);
}
