/* $Id: icon.h 448 2011-02-26 07:26:08Z oh2gve $
 *
 * Copyright 2010, 2011 Tapio Aaltonen
 *
 *
 * This file is part of aprsg.
 *
 * aprsg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * aprsg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with aprsg.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * APRS is a registered trademark of APRS Software and Bob Bruninga, WB4APR.
*/

#ifndef ICON_H
#define ICON_H

#include <wx/taskbar.h>
#include <wx/frame.h>


/// Taskbar icon of the app.
/**
 * Icon creates a context menu on right click. Menu items cause events, which
 * are to be processed by owner of the icon object.
 */
class Icon: public wxTaskBarIcon
{
public:

	// Constructor and destructor.
	Icon(wxFrame* parent);
	virtual ~Icon();

	// Called by framework whenever menu is needed.
	virtual wxMenu* CreatePopupMenu();

	// Status operator.
	/**
	 * Use this at least after initialization to check how it went.
	 */
	bool operator!() const;

private:

	// Flag for reporting errors to main.
	bool error_;

	// Our parent window.
	wxFrame* parent_;

	// Events created by menu.
	enum eventIds { ID_toggleWindow, ID_close };

	// Event handlers for menu events.
	void onToggleWindow(wxCommandEvent& event);
	void onClose(wxCommandEvent& event);

	DECLARE_EVENT_TABLE()
};

#endif // ICON_H
